"use strict";
exports.__esModule = true;
var coffee_lex_1 = require("coffee-lex");
var CoffeeScript = require("decaffeinate-coffeescript");
var coffee_script_1 = require("./ext/coffee-script");
var mapProgram_1 = require("./mappers/mapProgram");
var fixLocations_1 = require("./util/fixLocations");
var ParseContext_1 = require("./util/ParseContext");
function parse(source) {
    coffee_script_1.patchCoffeeScript();
    var context = ParseContext_1["default"].fromSource(source, coffee_lex_1["default"], CoffeeScript.nodes);
    fixLocations_1["default"](context, context.ast);
    var program = mapProgram_1["default"](context);
    traverse(program, function (node, parent) {
        node.parentNode = parent;
    });
    return program;
}
exports.parse = parse;
function traverse(node, callback) {
    function traverseRec(currentNode, currentParent) {
        var shouldDescend = callback(currentNode, currentParent);
        if (shouldDescend !== false) {
            for (var _i = 0, _a = currentNode.getChildren(); _i < _a.length; _i++) {
                var child = _a[_i];
                traverseRec(child, currentNode);
            }
        }
    }
    traverseRec(node, null);
}
exports.traverse = traverse;
